diff --git a/gcc/tree-vect-data-refs.c b/gcc/tree-vect-data-refs.c
index 89f66bc..9978de3 100644
--- a/gcc/tree-vect-data-refs.c
+++ b/gcc/tree-vect-data-refs.c
@@ -5081,7 +5081,7 @@ vect_grouped_store_supported (tree vectype, unsigned HOST_WIDE_INT count)
 	      if (!can_vec_perm_const_p (mode, indices))
 		{
 		  if (optinfo_enabled_p ())
-		    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		    OPTINFO_VECT_FAILURE
 		      << "permutation op not supported by target";
 		  return false;
 		}
@@ -5099,7 +5099,7 @@ vect_grouped_store_supported (tree vectype, unsigned HOST_WIDE_INT count)
 	      if (!can_vec_perm_const_p (mode, indices))
 		{
 		  if (optinfo_enabled_p ())
-		    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		    OPTINFO_VECT_FAILURE
 		      << "permutation op not supported by target";
 		  return false;
 		}
@@ -5133,7 +5133,7 @@ vect_grouped_store_supported (tree vectype, unsigned HOST_WIDE_INT count)
     }
 
   if (optinfo_enabled_p ())
-    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+    OPTINFO_VECT_FAILURE
       << "permutation op not supported by target";
   return false;
 }
@@ -5646,7 +5646,7 @@ vect_grouped_load_supported (tree vectype, bool single_element_p,
   if (single_element_p && maybe_gt (count, TYPE_VECTOR_SUBPARTS (vectype)))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	OPTINFO_VECT_FAILURE << (
 			 "single-element interleaving not supported "
 			 "for not adjacent vector loads\n");
       return false;
@@ -5657,7 +5657,7 @@ vect_grouped_load_supported (tree vectype, bool single_element_p,
   if (count != 3 && exact_log2 (count) == -1)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	OPTINFO_VECT_FAILURE << (
 			 "the size of the group of accesses"
 			 " is not a power of 2 or not equal to 3\n");
       return false;
@@ -5673,7 +5673,7 @@ vect_grouped_load_supported (tree vectype, bool single_element_p,
 	  if (!GET_MODE_NUNITS (mode).is_constant (&nelt))
 	    {
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+		OPTINFO_VECT_FAILURE << (
 				 "cannot handle groups of 3 loads for"
 				 " variable-length vectors\n");
 	      return false;
@@ -5694,7 +5694,7 @@ vect_grouped_load_supported (tree vectype, bool single_element_p,
 	      if (!can_vec_perm_const_p (mode, indices))
 		{
 		  if (optinfo_enabled_p ())
-		    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+		    OPTINFO_VECT_FAILURE << (
 				     "shuffle of 3 loads is not supported by"
 				     " target\n");
 		  return false;
@@ -5708,7 +5708,7 @@ vect_grouped_load_supported (tree vectype, bool single_element_p,
 	      if (!can_vec_perm_const_p (mode, indices))
 		{
 		  if (optinfo_enabled_p ())
-		    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+		    OPTINFO_VECT_FAILURE << (
 				     "shuffle of 3 loads is not supported by"
 				     " target\n");
 		  return false;
@@ -5740,7 +5740,7 @@ vect_grouped_load_supported (tree vectype, bool single_element_p,
     }
 
   if (optinfo_enabled_p ())
-    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+    OPTINFO_VECT_FAILURE << (
 		     "extract even/odd not supported by target\n");
   return false;
 }
@@ -6083,7 +6083,7 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	    OPTINFO_VECT_FAILURE << (
 			     "shuffle of 2 fields structure is not \
 			      supported by target\n");
 	  return false;
@@ -6098,7 +6098,7 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	    OPTINFO_VECT_FAILURE << (
 			     "shuffle of 2 fields structure is not \
 			      supported by target\n");
 	  return false;
@@ -6113,7 +6113,7 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	    OPTINFO_VECT_FAILURE << (
 			     "shift permutation is not supported by target\n");
 	  return false;
 	}
@@ -6129,7 +6129,7 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
+	    OPTINFO_VECT_FAILURE << (
 			     "select is not supported by target\n");
 	  return false;
 	}
@@ -6193,9 +6193,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
-			     "shuffle of 3 fields structure is not \
-			      supported by target\n");
+	    OPTINFO_VECT_FAILURE
+	      << "shuffle of 3 fields structure is not supported by target";
 	  return false;
 	}
       perm3_mask = vect_gen_perm_mask_checked (vectype, indices);
@@ -6208,8 +6207,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
-			     "shift permutation is not supported by target\n");
+	    OPTINFO_VECT_FAILURE
+	      << "shift permutation is not supported by target";
 	  return false;
 	}
       shift1_mask = vect_gen_perm_mask_checked (vectype, indices);
@@ -6222,8 +6221,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
-			     "shift permutation is not supported by target\n");
+	    OPTINFO_VECT_FAILURE
+	      << "shift permutation is not supported by target";
 	  return false;
 	}
       shift2_mask = vect_gen_perm_mask_checked (vectype, indices);
@@ -6236,8 +6235,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
-			     "shift permutation is not supported by target\n");
+	    OPTINFO_VECT_FAILURE
+	      << "shift permutation is not supported by target";
 	  return false;
 	}
       shift3_mask = vect_gen_perm_mask_checked (vectype, indices);
@@ -6250,8 +6249,8 @@ vect_shift_permute_load_chain (vec<tree> dr_chain,
       if (!can_vec_perm_const_p (TYPE_MODE (vectype), indices))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << (
-			     "shift permutation is not supported by target\n");
+	    OPTINFO_VECT_FAILURE
+	      << "shift permutation is not supported by target";
 	  return false;
 	}
       shift4_mask = vect_gen_perm_mask_checked (vectype, indices);
